// -*-C++-*-
//
// XMM Science Analysis System
//
// Giuseppe Vacanti (European Space Agency) 
// April 20, 1999
//

// calview GUI object

#ifndef Calview_Gui_H
#define Calview_Gui_H

#include "SasTaskWindow.h"
#include <CalView.h>

#include <map>

class QPopupMenu;
class QMenuBar;

class CalviewGui : public SasTaskWindow
{
  Q_OBJECT
    
public:
  CalviewGui(const char *name);
  ~CalviewGui();

  signals:
  void viewerComplete();
  
private slots:
    
  void setNewCcfDirectory();
  void setNewCcfCif();
  void insertCcf();
  void listCcf();
  void notImplemented();
  void viewDispatcher(int);
  void donothing();
  void updateViewables();
  void showState();

private:
  QMenuBar*   menuBarInit();
  QPopupMenu* _view;
  map<int, const CalViewable *> _call_back;

  typedef vector<const CalViewable *>::const_iterator VI;

  void processViewable(const CalViewable* v,
		       QPopupMenu* qpm
		       );

  // Use this counter to label the intermediate data sets
  unsigned long _ds_counter ;

  string calview_ds();
};

#endif
