//
// XMM Science Analysis System
//
// Giuseppe Vacanti (European Space Agency) 
// August 1999
//

#include <Tracer.h>
#include <CalServer.h>

#include <qspinbox.h>

#include "CameraTemperatureSelector.h"

CameraTemperatureSelector::CameraTemperatureSelector(QWidget * parent=0, const char * name=0)
  : QSpinBox(parent,name)
{
  PROC
  init();  
  ENDPROC
}


void CameraTemperatureSelector::init()
{
  PROC
  if(calServer.state()->temperatureCamera()->isActive()){
    setEnabled(true);
    setValue(static_cast<int>(calServer.state()->temperatureCamera()->get()));
    setRange(static_cast<int>(calServer.state()->temperatureCamera()->min()),
	     static_cast<int>(calServer.state()->temperatureCamera()->max()));
  } else {
    setEnabled(false);
  }
  connect(this, SIGNAL(valueChanged(int)), this, SLOT(myvaluechanged(int)));
  ENDPROC
}

void CameraTemperatureSelector::update()
{
  PROC
  init();
  ENDPROC
}

void CameraTemperatureSelector::myvaluechanged(int v)
{
  PROC
  calServer.state()->temperatureCamera()->set(v);
  emit calStateIsUpdated();
  ENDPROC
}
