//
// XMM Science Analysis System
//
// Giuseppe Vacanti (European Space Agency) 
// February 24, 1999
//

#include <string>

#include <Tracer.h>
#include <CalServer.h>

#include "CcdBgroup.h"
#include <iostream>
#include <strstream>
#include <qcombobox.h> 

CcdBgroup::CcdBgroup(QWidget * parent=0, const char * name=0 )
  : QComboBox(parent, name)
{
  PROC
  init();
  ENDPROC
}

void CcdBgroup::init()
{
  PROC
  CalState *state = calServer.state();
  clear();
  if (state->ccd()->isActive()) {
    setEnabled(true);
    for (Ccd ccd = state->ccd()->min(); ccd <= state->ccd()->max(); ccd++) {
      ostrstream os;
      os << ccd << ends;
      insertItem(os.str(), ccd-1);
    }
    connect(this, SIGNAL(activated(int)), this, SLOT(myactivated(int)));
  } else {
    setEnabled(false);
  }
  ENDPROC
}

void CcdBgroup::update()
{
  PROC
  init();
  ENDPROC
}

void CcdBgroup::myactivated(int i)
{
  PROC
  calServer.state()->ccd()->set(i+1);
  emit calStateIsUpdated();
  ENDPROC
}
