//
// XMM Science Analysis System
//
// Giuseppe Vacanti (European Space Agency) 
// February 24, 1999
//

#include <Tracer.h>
#include <CalServer.h>

#include "CcfLogger.h"

#include <qtooltip.h>


CcfLogger::CcfLogger(QWidget * parent=0, const char * name=0 )
  : QTextView(parent, name)
{
  PROC
    QToolTip::add(this, "Current Calibration File constituents accessed during the last view.");
  ENDPROC
}

void CcfLogger::update()
{
  PROC
  erase();
  CcfAccessLog &ccflog = calServer.ccfAccessLog();
  QString text;
  for(CcfAccessLog::const_iterator k=ccflog.begin(); k!=ccflog.end(); ++k){
    text.append(k->fileName().c_str());
    text.append("\n");
  }
  setText(text);  
  ENDPROC
}
