//
// XMM Science Analysis System
//
// Giuseppe Vacanti (European Space Agency) 
// February 23, 1999
//

#include <map>
#include <string>

#include <qcombobox.h>

#include <Xmm.h>
#include <Tracer.h>
#include <CalServer.h>

#include "InstrumentBgroup.h"

InstrumentBgroup::InstrumentBgroup(QWidget * parent=0, const char * name=0 )
  : QComboBox(parent, name)
{
  PROC
  init();
  ENDPROC
}

void InstrumentBgroup::init()
{
  PROC
  typedef vector<XmmInstrument *>::const_iterator VI;
  for(VI i = xmmPayLoad.instruments().begin(); i != xmmPayLoad.instruments().end(); i++){
    insertItem(Xmm::toString((*i)->id()).c_str());
  }
  
  for(int i = 0; i < count(); i++){
    if(text(i) == Xmm::toString(calServer.instrument()->id()).c_str()){
      setCurrentItem(i);
    }
  }
  
  connect(this, SIGNAL(activated(const QString &)), this, SLOT(myactivated(const QString &)));
  ENDPROC
}

void InstrumentBgroup::myactivated(const QString & s)
{
  PROC
  calServer.setInstrument(Xmm::toInstrument(string(s)));
  emit calStateIsUpdated();
  ENDPROC
}
