//
// XMM Science Analysis System
//
// Giuseppe Vacanti (European Space Agency) 
// August 1999
//

#include <Tracer.h>
#include <CalServer.h>
#include <STime.h>

#include "ObservationStartTimeSelector.h"

ObservationStartTimeSelector::ObservationStartTimeSelector(QWidget * parent=0,
							   const char * name=0)
  : QLineEdit(parent,name)
{
  PROC
  init();  
  ENDPROC
}

void ObservationStartTimeSelector::init()
{
  PROC
  if(calServer.state()->observationStartTime()->isActive()){
    setEnabled(true);
    STime t = calServer.state()->observationStartTime()->get();
    t = t - t.fracSeconds();
    setText(QString(t.toString().c_str()));
    setMaxLength(19);
  } else {
    setEnabled(false);
  }
  //  connect(this, SIGNAL(textChanged(const QString &)), this, SLOT(myvaluechanged(const QString &)));
  connect(this, SIGNAL(returnPressed()), this, SLOT(myvaluechanged()));
  ENDPROC
}

void ObservationStartTimeSelector::update()
{
  PROC
  init();
  ENDPROC
}

//  void ObservationStartTimeSelector::myvaluechanged(const QString & s)
//  {
//    PROC
//    calServer.state()->observationStartTime()->set(STime(string(s)));
//    emit calStateIsUpdated();
//    ENDPROC
//  }
void ObservationStartTimeSelector::myvaluechanged()
{
  PROC
  calServer.state()->observationStartTime()->set(STime(string(text())));
  emit calStateIsUpdated();
  ENDPROC
}
