//
// XMM Science Analysis System
//
// Giuseppe Vacanti (European Space Agency) 
// August 1999
//

#include <Tracer.h>
#include <CalServer.h>

#include "OcbSelector.h"

OcbSelector::OcbSelector(QWidget * parent=0, const char * name=0)
  : QSpinBox(parent,name)
{
  PROC
  init();  
  ENDPROC
}


void OcbSelector::init()
{
  PROC
  if(calServer.state()->ocb()->isActive()){
    setEnabled(true);
    setValue(static_cast<int>(calServer.state()->ocb()->get()));
    setRange(static_cast<int>(calServer.state()->ocb()->min()),
	     static_cast<int>(calServer.state()->ocb()->max()));
  } else {
    setEnabled(false);
  }
  connect(this, SIGNAL(valueChanged(int)), this, SLOT(myvaluechanged(int)));
  ENDPROC
}

void OcbSelector::update()
{
  PROC
  init();
  ENDPROC
}

void OcbSelector::myvaluechanged(int v)
{
  PROC
  calServer.state()->ocb()->set(static_cast<unsigned>(v));
  emit calStateIsUpdated();
  ENDPROC
}
