//
// XMM Science Analysis System
//
// Giuseppe Vacanti (European Space Agency) 
// March 2000
//

#include <Tracer.h>
#include <CalView.h>

#include <qspinbox.h>
#include <qtooltip.h>
#include <strstream>

#include "PhiSelector.h"

PhiSelector::PhiSelector(QWidget * parent=0, const char * name=0)
  : QSpinBox(parent,name)
{
  PROC
  init();  
  ENDPROC
}


void PhiSelector::init()
{
  PROC
  CalViewState * state = calViewServer.state();
  if(state->phi.isActive()){
    setEnabled(true);
    setValue(static_cast<int>(state->phi.get()));
    setRange(static_cast<int>(state->phi.min()), static_cast<int>(state->phi.max()));
    strstream s;
    s << "Range: " << state->phi.min() << " to " << state->phi.max() << ends;
    QToolTip::add(this, s.str());

  } else {
    setEnabled(false);
  }
  connect(this, SIGNAL(valueChanged(int)), this, SLOT(myvaluechanged(int)));
  ENDPROC
}

void PhiSelector::update()
{
  PROC
  init();
  ENDPROC
}

void PhiSelector::myvaluechanged(int v)
{
  PROC
  CalViewState * state = calViewServer.state();
  state->phi.set(v);
  emit calStateIsUpdated();
  ENDPROC
}
