//
// XMM Science Analysis System
//
// Giuseppe Vacanti (European Space Agency) 
// March 2000
//

#include <Tracer.h>
#include <CalView.h>

#include <qspinbox.h>
#include <qtooltip.h>
#include <strstream>

#include "SpectralOrderSelector.h"

SpectralOrderSelector::SpectralOrderSelector(QWidget * parent=0, const char * name=0)
  : QSpinBox(parent,name)
{
  PROC
  init();  
  ENDPROC
}


void SpectralOrderSelector::init()
{
  PROC
  CalViewState * state = calViewServer.state();
  if(state->spectralOrder.isActive()){
    setEnabled(true);
    setValue(static_cast<int>(state->spectralOrder.get()));
    setRange(static_cast<int>(state->spectralOrder.min()), static_cast<int>(state->spectralOrder.max()));
    strstream s;
    s << "Range: " << state->spectralOrder.min() << " to " << state->spectralOrder.max() << ends;
    QToolTip::add(this, s.str());


  } else {
    setEnabled(false);
  }
  connect(this, SIGNAL(valueChanged(int)), this, SLOT(myvaluechanged(int)));
  ENDPROC
}

void SpectralOrderSelector::update()
{
  PROC
  init();
  ENDPROC
}

void SpectralOrderSelector::myvaluechanged(int v)
{
  PROC
  CalViewState * state = calViewServer.state();
  state->spectralOrder.set(v);
  emit calStateIsUpdated();
  ENDPROC
}
